// globals

	var invitedScreenNames = window.arguments[0].invitedScreenNames;
		dump('got invitedScreenNames'+invitedScreenNames+"\n\n")	
	var chatRoomName= window.arguments[0].chatRoomName;
		dump('got chatRoomName'+chatRoomName+"\n\n")	
	var chatMsg = window.arguments[0].chatMsg;
		dump("got chatMsg "+chatMsg+"\n\n")
	var chatPanelLoaded = false;

// globals for invite

	var incomingChat	= window.arguments[0].incomingChat;
	var	inviteProposalScreenName = window.arguments[0].incomingChatInviteProposalScreenName;
	var	inviteProposalObj= window.arguments[0].incomingChatInviteProposalObj;
	

//ChatRoomManager setup 
//         ***start***
function chatRoomMemberObj(screenName,status,ignored,blocked){
	this.screenName=screenName;
	this.status=status;
	this.ignored=ignored;
	this.blocked=blocked;
	return this;
}


function chatRoomManagerObj(){
	this.members = new Array();
	this.roomname = "";
	
	return this;
	}	

function chatRoomManagerAddMember(managerObj,membername,status,ignored,blocked){
	managerObj.members[managerObj.members.length] = new chatRoomMemberObj(membername,status,ignored,blocked);
	dump("chatRoomManagerAddMember: "+membername+"\n");
}

function chatRoomManagerShowMembers(managerObj){
	for(i=0;i<managerObj.members.length;i++){
		alert(managerObj.members[i].screenName);
	}
}

function chatRoomManagerDelMember(managerObj,membername){
	var tempMembersArray = new Array();
	for(k=0;k<managerObj.members.length;k++){
		if(managerObj.members[k].screenName.toLowerCase() == membername.toLowerCase()){
			//copy members to new Array, except for deleted one.
			for(m=0;m<managerObj.members.length;m++){
				if(m!=k){
					tempMembersArray[tempMembersArray.length] = managerObj.members[m];	
				}
			}
			//swap old array with new one.
			managerObj.members = tempMembersArray;
		}
	}
		dump("chatRoomManagerDelMember: "+membername+"\n");

	
}

function chatRoomManagerUpdateMember(managerObj,membername,status){
	var changedFlag = false;
		for(i=0;i<managerObj.members.length;i++){
			if(managerObj.members[i].screenName.toLowerCase()==membername.toLowerCase()){
				managerObj.members[i].status = status
				changedFlag=true;
			}

		}
		if(!changedFlag){
			//didnt change anyone - must not be here yet!
			chatRoomManagerAddMember(managerObj,membername,status,false,false)
		}
		
		dump("chatRoomManagerUpdateMember[of "+managerObj.members.length+" ]: "+membername+"\n");

}


 var myManager = new chatRoomManagerObj();

//ChatRoomManager setup ***end***






// Setup Callbacks


//Setup Room Callbacks (basically event capturing)

var RoomCallback= new Object();

RoomCallback.OnMessageReceived = function(screenName, rcvdMsg, language){
	dump("OnMessageReceived:"+rcvdMsg+"\n");
	dump (screenName + " SAYETH " + rcvdMsg + " IN " + language +"\n");
	chatContentRecieveMsg(screenName,rcvdMsg)
}

RoomCallback.OnWhisperReceived = function(screenName,  rcvdWhispMsg, language){
	dump("OnWhisperReceived:"+rcvdWhispMsg+"\n");
	chatContentRecieveMsg(screenName,rcvdWhispMsg)
}


RoomCallback.OnLeft = function(errorMsg){
	dump("Onleft: error["+errorMsg+"] \n");
	chatContentReceiveStatus(null, aimString("chat.YouLeft").replace(/%ChatRoom%/, chatRoomName));
	updateStatus(aimString("chat.YouLeft").replace(/%ChatRoom%/, chatRoomName));
}

RoomCallback.OnJoined = function(){
	dump("OnJoin: \n")
	dump("Yes I Joined\n");
	chatContentReceiveStatus(null, aimString("chat.YouJoined").replace(/%ChatRoom%/, chatRoomName));
	updateStatus(aimString("chat.YouJoined").replace(/%ChatRoom%/, chatRoomName));

}

RoomCallback.OnUserJoined = function(screenName){
  dump("OnUserJoined:"+screenName+"\n");
  updateStatus(aimString("chat.OnUserJoined").replace(/%ScreenName%/, screenName));
	//update their status in the list
	top.frames['chatpanel'].chatPanelUpdateScreenName(screenName,"joined treecell-iconic")
	
	//update their status in the global obj
	chatRoomManagerUpdateMember(myManager,screenName,"joined")
	try {
		chatAnnounce_pref=aimPrefsManager().GetBoolPref("aim.chat.AnnounceChatRoom", null, false);
		}
		catch (ex) {
			chatAnnounce_pref = true;
   		}

	var currentScreenName = aimSessionCurrentScreenName();      
    if ((chatAnnounce_pref && (currentScreenName != screenName)))
    {
		chatContentReceiveStatus(screenName, aimString("chat.OnUserJoined").replace(/%ScreenName%/,""));
	}
	chatRoomManagerUpdateMember(myManager,screenName,"joined treecell-iconic")

}

RoomCallback.OnUserLeft = function(screenName){
  dump("OnUserLeft:"+screenName+"\n");
  updateStatus(aimString("chat.OnUserLeft").replace(/%ScreenName%/, screenName));
	top.frames['chatpanel'].chatPanelRemoveScreenName(screenName)
	//update global obj
	chatRoomManagerDelMember(myManager,screenName)

	var chatAnnounce_pref;
	try {
		chatAnnounce_pref=aimPrefsManager().GetBoolPref("aim.chat.AnnounceChatRoom", null, false);
		}
	catch (ex) {
       	chatAnnounce_pref = true;
        }
    if (chatAnnounce_pref)
    {
		chatContentReceiveStatus(screenName, aimString("chat.OnUserLeft").replace(/%ScreenName%/, ""));
	}
	
	
}

RoomCallback.OnPaused = function(){
    dump("OnPaused: \n");
    //chatContentReceiveStatus(null,aimString("chat.RoomPaused"));
    updateStatus(aimString("chat.RoomPaused"));

}

RoomCallback.OnResumed = function(){
    dump("OnResumed: \n");
    //chatContentReceiveStatus(null,aimString("chat.RoomResumed"));
    updateStatus(aimString("chat.RoomResumed"));
}

RoomCallback.OnInfoUpdate = function(){
	dump("OnInfoUpdate: \n")
	
}

RoomCallback.OnClientError = function(screenName,errMsg){
    dump("OnClientError: error["+screenName+" : "+errMsg+"]\n");
    //chatContentReceiveStatus(screenName,aimString("chat.ClientError"));
    updateStatus(aimString("chat.ClientError").replace(/%ScreenName%/, screenName));
}


// end Setup Room Callback




// Setup ChatManager Callback 

var CallBack = new Object();
var RoomCreationTimeStamp = null;
CallBack.title = aimString("chat.WindowTitle");

CallBack.OnRequestRoomComplete =  function(roomName,chatRoomObj){
	dump("OnRequestRoomComplete: success on "+roomName+"\n");
	dump("chatRoomObj"+chatRoomObj+"\n")
	RoomCreationTimeStamp= new Date();
	chatRoomObj.SetChatRoomCallback( RoomCallback )
	top.chatRoomObj = chatRoomObj;
	
	dump("roomName is " + roomName + "\n");
	dump("chatRoomName is " + chatRoomName + "\n");
	dump("roomObjName is " + chatRoomObj.GetName() + "\n");

	if (roomName)
		window.title= aimString("chat.WindowTitle").replace(/%ChatRoom%/, roomName);
	else if (chatRoomName)
		window.title= aimString("chat.WindowTitle").replace(/%ChatRoom%/, chatRoomName);
	else if (chatRoomObj.GetName())
		window.title= aimString("chat.WindowTitle").replace(/%ChatRoom%/, chatRoomObj.GetName());
	
	window.setTimeout('top.chatRoomObj.Join()', 1000);
	
	window.setTimeout('chatContentInviteMany(invitedScreenNames,chatMsg)',1500);
	//window.setTimeout('top.chatRoomObj.SendMessage("This is working!!")', 30000);
	//window.setTimeout('top.chatRoomObj.SendWhisper("trip004", "Private message for vishy26aug")', 30000);
	
}


CallBack.OnRequestRoomError =  function(roomName,errMsg){
	dump("OnRequestRoomError: there was an error \n");

}

CallBack.OnProposalReceived = function(screenName,proposalObj){
	dump("OnProposalReceived:"+screenName+"  \n");

}



//Chat Sound handling

function chatSound(msg)
{
	aimSoundManager().ChatEvent(msg);
}

// first thing to do on startup

function chatContentStartup(){

	pChatManager = aimChatManager();
	if (!pChatManager)
	{
		dump("chatContentStartup:unable to get pChatManager\n");
		return;
	}
	else{
			dump("chatContentStartup:got  pChatManager\n");

	}


	dump("chatContentStartup: calling pChatManager.GetMaxConcurrentRooms\n");

	var rooms = new Object();
	
	try {
		dump("trying pChatManager.GetMaxConcurrentRooms(rooms) \n");
		pChatManager.GetMaxConcurrentRooms(rooms);
		}
	catch (e){
		dump("!!!!! catching js error during pChatManager.GetMacConcurrentRooms !!!!! \n")
		dump ("rooms.value: "+rooms.value + "\n");
	
	}
	
	

// got chatroom name from arguments passed to the opendialog


if(incomingChat){
/*
	try {
		dump("chatContentStartup: trying pChatManager.RequestProposedRoom\n");
		dump("inviteProposalObj:"+inviteProposalObj+"\n");

		pChatManager.RequestProposedRoom(CallBack, inviteProposalObj);
		}
	catch (e){
		dump("chatContentStartup: error loading pChatManager.RequestProposedRoom\n");
	
		alert("There was an error loading the Chat window");
		}	
*/
	dump("About to CallbackIncoming\n");
	CallBack.OnRequestRoomComplete(window.arguments[0].chatRoomName, window.arguments[0].incomingChatRoom);	

	}
else{	
	try {
		dump("chatContentStartup: trying pChatManager.RequestPrivateRoom\n");
		pChatManager.RequestPrivateRoom(CallBack,chatRoomName)
		}
	catch (e){
		dump("chatContentStartup: error loading pChatManager.RequestPrivateRoom\n");
		alert("There was an error loading the Chat window");
		}	
}


}


// One more level of callback in order that chat manager can be ready
myExecutionCallback = new Object();
myExecutionCallback.ExecuteIfReady = function()
{
// get chatroom and callbacks
  dump ("before chatContentStartup\n");
	chatContentStartup();
	dump("after Chatcontentstartup\n");
	
	// startup the ender widget
	startUpEditor(document.getElementById("ComposeWnd"));
	
	updateMemberCount();
	//chatContentAddMsgToLog('goober','hi');

	try{
		window.opener.close();
	}
	catch (e){
		dump("chat: where's my invite window?? \n")
	}	
}

// after the window has loaded:

function chatContentOnWinLoad(){

	aimChatManager().OnWindowLoad(top);
	aimChatManager().ExecuteIfReady(myExecutionCallback);
	
	

}


// window is closing

function chatContentOnWinUnLoad(){
	aimChatManager().OnWindowUnload(top);
	try{
		top.chatRoomObj.Leave()
		}
	catch (e){
		dump("chat: there was an error trying to call chatRoomObj.leave() \n");
	}	

}	



function startUpEditor(editorElement){

	if (!editorElement) {
		dump("No editor element found\n");
		return;
	}
	
	var editorShell = editorElement.editorShell;
	if(editorShell) {			
		// save the editorShell in the window. The editor JS expects to find it there.
		window.editorShell = editorShell;

		//SetupToolbarElements(); //defined into editor.js
		window.editorShell.editorType = "html";

		window.editorShell.contentWindow = window._content;
		window.editorShell.webShellWindow = window;
		window.editorShell.LoadUrl("chrome://aim/content/blank.html");
		EditorSharedStartup();
	} else {
		dump("No editorShell found\n");
		return;
	}
}


// updates the number of chat members (use after an add or delete member)

function updateMemberCount(){
		//theTree = document.getElementById("cptChildren");
		
		var theTreeChildren = top.frames["chatpanel"].document.getElementsByTagName("treecell")
		var activeMembers=0;
		
		for(i=0 ; i<theTreeChildren.length;i++){
			
			dump("updateMemberCount:class "+theTreeChildren.item(i).getAttribute("class")+"\n")
			dump("updateMemberCount:value "+theTreeChildren.item(i).getAttribute("value")+"\n")
			
			if(theTreeChildren.item(i).getAttribute("class") == "joined treecell-iconic"){
				activeMembers++;
			}
		}
		
		//dump("theTreeNode"+theTree+" \n")
		theMemberCountNode=document.getElementById("numberchatting")
		
		if(theMemberCountNode.childNodes.length >0){
			theMemberCountNode.removeChild(theMemberCountNode.childNodes.item(0))
			
		}
		
		
		if(activeMembers!=1){
		theMemberCountNode.appendChild(document.createTextNode(aimString("chat.PeopleHere").replace(/%NumPeople%/, activeMembers)));
		}
		else{
		theMemberCountNode.appendChild(document.createTextNode(aimString("chat.PersonHere")));
		}
}



//send your message out
function SendOnEnter()
{
	// if enterCR_pref_value is true, the pref was set so that enter was a CR
        // if enterCR_pref_value is false, the user wants enter to send the IM message
	try {
		enterCR_pref_value = aimPrefsManager().GetBoolPref("aim.general.im.enterCR", null, false);
	}
	catch (ex) {
		// default to be "send on enter key"
		enterCR_pref_value = true;
	}
	
	return (!enterCR_pref_value);
}


function chatContentSendMsg(strip){

	var bodyText = editorShell.GetContentsAs("text/html", 8 + 4 + 256);
	
	// *** placeholder for getting strip pref.
	//var strip=true

	if ( strip == true ) {
		bodyText = bodyText.replace(/<br>/gi, "");
		bodyText = bodyText.replace(/\n/g, "");
		bodyText = bodyText.replace(/\r/g, "");
	}

	bodyText = bodyText.replace(/\n/g, "");
	bodyText = bodyText.replace(/\r/g, "");
	bodyText = bodyText.replace(/<br><br>/gi, "<br>");
	bodyText = bodyText.replace(/<br><\/body>/i, "<\/body>");
	bodyText = bodyText.replace(/&nbsp;/gi, " ");
	
	//chatContentAddMsgToLog('noone',bodyText)
	top.chatRoomObj.SendMessage(bodyText)

	top.editorShell.SelectAll();
	top.editorShell.DeleteSelection(null);
	//*** return focus to editor after clicking send ***
	
	
	top._content.focus();

    //Chat Send Sound to hook
	dump("Outgoing Sound works!\n");
		chatSound(Components.interfaces.nsAimChatSoundEvent.ChatSoundEvent_OutgoingMsg);	

}



// handle incoming messages

function chatContentRecieveMsg(screenName,msg){
	var chatflash=false;         
	try {
		chatflash=aimPrefsManager().GetBoolPref("aim.chat.FlashChatWin", null, false); 
    }
    catch (ex) {
        chatflash = true;
    }               
    if (chatflash)
        	top.window.GetAttention();

	chatContentAddMsgToLog(screenName,msg,true)

	//Chat Receive Sound to Hook
	dump("INCOMING SOUND\n");
	chatSound(Components.interfaces.nsAimChatSoundEvent.ChatSoundEvent_IncomingMsg);
}

function chatContentReceiveStatus(screenName, msg) {
  chatContentAddMsgToLog(screenName,msg,false);
}


// sub function of chatContentRecieveMsg
function chatContentAddMsgToLog(screenName,msg,isMsg){
	var theLogNode = top.frames['LogWnd']
	
	var myRange = theLogNode.document.createRange();
	var theLogBody =theLogNode.document.getElementsByTagName("body").item(0)
		myRange.setStartAfter(theLogBody);
	var docFrag;
	// XXXVISHY - this handles info messages also
	if (screenName) {
	  var colorpre = " ";
	  var colorpost = " </b> ";
	  if (isMsg) // otherwise it is a status
	    {
	      if (screenName == aimSessionCurrentScreenName()) 
		colorpre = '<font color=\"#ff0000\">';
	      else
		colorpre = '<font color=\"#0000ff\">';
            
	      var colorpost = '</b>: </font>';
	    }
	
	  docFrag = myRange.createContextualFragment("<html>" + colorpre + "<b>"+screenName+ colorpost+msg+"</html><br>");
	} else
	    docFrag = myRange.createContextualFragment("<html>"+msg+"</html><br>");
	//theLogNode.scrollBy(0,10000);
	dump("document.height before" + theLogNode.document.height);

	theLogBody.appendChild(docFrag)
			
	dump("document.height after" + theLogNode.document.height+"\n");
	dump("scrollX"+ theLogNode.scrollX+"\n")
	dump("scrollY"+ theLogNode.scrollY+"\n")
	
	//theLogNode.scrollBy(0,10000);
	
	//if((theLogNode.scrollY + theLogNode.innerHeight) ==  theLogNode.document.height ){
	theLogNode.scrollTo(theLogNode.scrollX, theLogNode.document.height)
	//}
}






//send info to the status area
// defunct!
function updateStatus(statusMsg){
	var statusTextNode= document.getElementById("statustext");
	statusTextNode.setAttribute("value",statusMsg);

}


// handle status changes

function chatContentStatusChange(screenName,statusItem){
  //updateStatus(screenName+": "+statusItem)	
}


/*** Handle Proposal and ProposalOwner for Chat Invitations ***/
var proposals = new Array(); // of all the open proposals;
var aproposal = new Object();

function AimProposalOwner()
{
        this.OnProposalAcked = function( 
              pProposal) 
	{ dump("OnProposalAcked"); }
        
        this.OnProposalError = function( 
              pProposal,
              pErrMsg) 
	{ aimErrorBox(aimString("chat.NotAvailable").replace(/%ScreenName%/, pProposal.GetProposee())); 
	top.frames['chatpanel'].chatPanelRemoveScreenName(pProposal.GetProposee());
	chatRoomManagerDelMember(myManager,pProposal.GetProposee());
	}
        
        this.OnProposalAccepted = function( 
              pProposal) 
	{ dump("OnProposalAccepted"); }
        
        this.OnProposalRejected = function(  pProposal)
	{ dump("OnProposalRejected");
	aimErrorBox(aimString("chat.Declined").replace(/%ScreenName%/, pProposal.GetProposee()));
	top.frames['chatpanel'].chatPanelRemoveScreenName(pProposal.GetProposee());
	chatRoomManagerDelMember(myManager,pProposal.GetProposee());
	}
	          
        this.OnProposalCountered = function( 
              pProposal,
              pCounterProposal) 
	{ dump("OnProposalCountered"); }

        this.OnProposalTimeout = function(  pProposal)
	{ aimErrorBox(aimString("chat.TimedOut"));
	
	top.frames['chatpanel'].chatPanelRemoveScreenName(pProposal.GetProposee());
	chatRoomManagerDelMember(myManager,pProposal.GetProposee());
	}   

        this.OnProposalCancelled = function( 
              pProposal)
	{ dump("OnProposalCancelled"); 
	top.frames['chatpanel'].chatPanelRemoveScreenName(pProposal.GetProposee());
	chatRoomManagerDelMember(myManager,pProposal.GetProposee());
	}

	return this;
}

// handle many invitations
function chatContentInviteMany(inviteList,chatMsg){
	// convert carriage returns and newlines to commas 
	inviteList = inviteList.replace(/\n/gi, ",");
	inviteList = inviteList.replace(/\r/gi, ",");

	inviteArray=inviteList.split(",")
	for(inviteItem = 0; inviteItem<inviteArray.length; inviteItem++){
		//test to make sure the name isnt empty
		if(itemTest(inviteArray[inviteItem])){
		
			dump("Inviting["+inviteArray[inviteItem]+"]\n")
			
			aproposal = top.chatRoomObj.Invite(inviteArray[inviteItem], chatMsg);
			proposals[proposals.length] = aproposal;
			dump("proposals.length is " + proposals.length + "\n")
			proposals[proposals.length-1].SetOwner(new AimProposalOwner());
			dump("proposals.length is " + proposals.length + "\n");
			//proposals.length++;
			
			top.frames['chatpanel'].chatPanelUpdateScreenName(inviteArray[inviteItem],"invited treecell-iconic")
		
			chatRoomManagerAddMember(myManager,inviteArray[inviteItem],"invited treecell-iconic",false,false)
		
			dump("Invited: "+inviteArray[inviteItem]+"\n");
		}
	}
	

}



function itemTest(inviteItem){
	var passed = true;


	switch(inviteItem) {
	
		case "": 
		case " ": passed = false;
		break;
		
	
	}


	dump("itemTest: "+passed+"\n");
	return passed;
}

// pop up invitation window:

function cmdPopUpInvite(screenNames){
	//window.openDialog('chrome://aim/content/chatInviteBuddy.xul','inviteBuddy','chrome,all,dialog=no','',true,"outgoingchat"); 
     inviteArgsObj = {
     	inviteProposalScreenName: '', 
     	inviteProposalObj: null,
     	invitedScreenNames: screenNames,
     	inviteToExistingWindow: true,
     	inviteMode: 'outgoingchat',
	inviteToExistingRoom: chatRoomName
     	}
     		
	window.openDialog('chrome://aim/content/chatInviteBuddy.xul','inviteBuddy','chrome,all,dialog=no',inviteArgsObj); 

}

// display room info

function cmdRoomInfo(){
	window.openDialog('chrome://aim/content/chatRoomInfo.xul','inviteBuddy','chrome,all,dialog=yes,resizable=no,titlebar',chatRoomName, top.chatRoomObj.GetLanguage(), top.chatRoomObj.GetMaxMessageLength(),RoomCreationTimeStamp.toLocaleString()); 
}

function createInstance( contractid, iidName )
{
	var iid = eval( "Components.interfaces." + iidName );
    return Components.classes[ contractid ].createInstance( iid );
}


function cmdFilePrint()
{
	dump("Implement Menu Command cmdFilePrint()\n");
	top.frames["LogWnd"].print();
}


function fixScrolling(){
	var LogWindow = top.frames["LogWnd"]
	var pageY = LogWindow.pageYOffset
	var docHeight = LogWindow.innerHeight

}
