var RDFClass = Components.classes['@mozilla.org/rdf/rdf-service;1'];
var RDF = RDFClass.getService(Components.interfaces.nsIRDFService);
var aim = RDF.GetDataSource("rdf:AIM");
var containerClass = Components.classes['@mozilla.org/rdf/container;1'];
var container = containerClass.createInstance(Components.interfaces.nsIRDFContainer);
container.Init(aim, RDF.GetResource("NC:AIM/BuddyList"));

function BuildGroupFrame()	
{
	var a = new Array();
	var i = 0;
	top.a = a;

	var enumerator = container.GetElements();

	while (enumerator.hasMoreElements()) {

		var element = enumerator.getNext();
		var resource = element.QueryInterface(Components.interfaces.nsIRDFResource);
		dump( "Element is " + element + "\n" );
		dump( "Resource is " + resource + "\n" );
		var attr = aim.GetTarget(resource, 
			RDF.GetResource("http://home.netscape.com/NC-rdf#Name"), true);
		if (attr)
			attr = attr.QueryInterface(Components.interfaces.nsIRDFLiteral);
		if (attr) {
			attr = attr.Value;
			a[ i ] = attr;
			i = i + 1;
		}
	}
	CreateGroupList( a );
}

function CreateGroupList( a )
{


	listDocument = document.getElementById("AddBuddyGroupList")
	
	listDocument.appendChild(document.createElement("spring"))
	
	for ( var i=0; i < a.length; i++ ) {
		chkboxname = "checkBox" + a[i];
		outputElement = document.createElement('checkbox')
		outputElement.setAttribute('id',chkboxname)
		outputElement.setAttribute('name',a[i])
		outputElement.setAttribute('value',a[i])
		listDocument.appendChild(outputElement)	
		//dump("docwriting!"+ outputElement +"\n" );
	}
	listDocument.appendChild(document.createElement("spring"))

}

function GetCheckBoxState( a, i )
{
	chkboxname = "checkBox" + a[i];
	chkbox = document.getElementById(chkboxname);
	return( chkbox.checked );
}

// for later 

function FindSelectedGroup()
{
	// Locate selection in setup list
	// XXX There must be a better way to do this

	var selectedGroup = null;
	var tree = window.tree;
	dump( "Tree is " + tree + "\n" );
	DumpDOM( tree );
	var groups = tree.childNodes[2].childNodes;

	for (var i = 0; i != groups.length; i++) {
		if (groups[i].getAttribute("selected") == "true") {
			selectedGroup = groups[i].getAttribute("Name");
			break;
		}
	}
	return( selectedGroup );
}

function FindBuddySelected( group, tree )
{
	var buddyList;
	
	if ( tree )
		buddyList = tree.selectedItems;

	if ( !buddyList || buddyList.length != 1 )
		return null;
	return( buddyList[0].getAttribute("Name") );
}
